% AUTHOR        : RONAK PATEL
% ADVISOR       : DR. LONGIN JAN LATECKI
% PROJECT 1     : COLORFUL!
% INPUT ARGUMENT: ronak_movie

function ronak_movie(action);

play= 1;
stop=-1;

if nargin<1,
    action='initialize';
end;

if strcmp(action,'initialize'),
    
    %Display Text and Frame Title
    
    oldFigNumber=watchon;
    figNumber=figure( ...
        'Name','Colorful!', ...
        'NumberTitle','off', ...
        'Visible','off');
    axes( ...
        'Units','normalized', ...
        'Position',[0.05 0.05 0.75 0.90], ...
        'Visible','off');
    text(0,0,'Press the "Start" button to see the Movie', ...
        'HorizontalAlignment','center');
    axis([-1 1 -1 1]);
    
    % Information for all buttons
   
    labelColor=[0.8 0.8 0.8];
    yInitPos=0.90;
    xPos=0.85;
    btnLen=0.10;
    btnWid=0.10;
    spacing=0.05;
    
    
    % The CONSOLE frame

    frmBorder=0.02;
    yPos=0.05-frmBorder;
    frmPos=[xPos-frmBorder yPos btnLen+2*frmBorder 0.9+2*frmBorder];
    h=uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
        'BackgroundColor',[0.50 0.50 0.50]);
    
    
    % The START button
    btnNumber=1;
    yPos=0.90-(btnNumber-1)*(btnWid+spacing);
    labelStr='Start';
    cmdStr='start';
    callbackStr='ronak_movie(''start'');';
    
    btnPos=[xPos yPos-spacing btnLen btnWid];
    startHndl=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',labelStr, ...
        'Interruptible','on', ...
        'Callback',callbackStr);
    
    
    % The SPIN button
    btnNumber=2;
    yPos=0.90-(btnNumber-1)*(btnWid+spacing);
    labelStr='Spin';
    callbackStr='ronak_movie(''spin'');';
    
    btnPos=[xPos yPos-spacing btnLen btnWid];
    spinHndl=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'Enable','off', ...
        'String',labelStr, ...
        'Callback',callbackStr);
    
    
    % The PLAY button    
    btnNumber=3;
    yPos=0.90-(btnNumber-1)*(btnWid+spacing);
    labelStr='play again';
    callbackStr='ronak_movie(''play'');';
    
    btnPos=[xPos yPos-spacing btnLen btnWid];
    playHndl=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'Enable','off', ...
        'String',labelStr, ...
        'Callback',callbackStr);
    
    % The BACK button
    btnNumber=4;
    yPos=0.90-(btnNumber-1)*(btnWid+spacing);
    labelStr='Back';
    callbackStr='ronak_movie(''back'');';
    
    btnPos=[xPos yPos-spacing btnLen btnWid];
    backHndl=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'Enable','off', ...
        'String',labelStr, ...
        'Callback',callbackStr);
    
    % The PLAY FULL button
    btnNumber=5;
    yPos=0.90-(btnNumber-1)*(btnWid+spacing);
    labelStr='Play Full';
    callbackStr='ronak_movie(''full'');';
    
    btnPos=[xPos yPos-spacing btnLen btnWid];
    fullHndl=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'Enable','on', ...
        'String',labelStr, ...
        'Callback',callbackStr);
    
    
    % The CLOSE button
    labelStr='Close';
    callbackStr='ronak_movie(''close'');';
    closeHndl=uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[xPos 0.05 btnLen 0.10], ...
        'Enable','on', ...
        'String',labelStr, ...
        'Callback',callbackStr);
    
    
    hndlList=[startHndl spinHndl playHndl backHndl fullHndl closeHndl];
    set(figNumber, ...
        'Visible','on', ...
        'UserData',hndlList);
    watchoff(oldFigNumber);
    figure(figNumber);
    
    
elseif (strcmp(action,'start')|strcmp(action,'spin')|strcmp(action,'back')|strcmp(action,'play')|strcmp(action,'full'))
    
    axHndl=gca;
    figNumber=gcf;
    hndlList=get(figNumber,'Userdata');
    startHndl=hndlList(1);
    spinHndl=hndlList(2);
    playHndl=hndlList(3);
    backHndl=hndlList(4);
    fullHndl=hndlList(5);
    closeHndl=hndlList(6);
    set([startHndl spinHndl playHndl backHndl fullHndl closeHndl],'Enable','off');
    
    
    % Create Movie Object
    aviFileName = 'movie8.avi';
    framesPerSec = 7; % 'frames per second' parameter for the .avi file.
    aviobj = avifile(aviFileName,'fps',framesPerSec,'COMPRESSION','NONE'); % initialize .avi file object.   
    
    
    %START OR FULL
    if(strcmp(action,'start')|strcmp(action,'full'))
        
        l=-90;
        k=-50;
        for(i=1:6)
            t = 0:pi/10:i*pi;
            [Z,Y,X] = cylinder(4*cos(t));
            
            surf(X,Y,Z)
            grid off
            axis off
            view(l,k)
            aviobj = addframe(aviobj,getframe);
            
        end
        
        for(j=0:5)
            t = 0:pi/10:((6-j)*pi);
            [Z,Y,X] = cylinder(4*cos(t));
            surf(X,Y,Z)
            grid off
            axis off
            view(l,k)
            aviobj = addframe(aviobj,getframe);
            
        end
        if strcmp(action,'start')
            set([startHndl spinHndl fullHndl closeHndl],'Enable','on');
            aviobj = close(aviobj);
        end
    end
    
    
    % SPIN OR FULL
    
    l=-90;
    k=-50;
    if (strcmp(action,'spin')|strcmp(action,'full'))
        
        startHndl=hndlList(1);
        spinHndl=hndlList(2);
        playHndl=hndlList(3);
        backHndl=hndlList(4);
        fullHndl=hndlList(5);
        closeHndl=hndlList(6);
        set([startHndl spinHndl playHndl backHndl fullHndl closeHndl],'Enable','off');
        m=0;
        for(i=1:6)
            t = 0:pi/10:i*pi;
            [Z,Y,X] = cylinder(4*cos(t));
            
            surf(X,Y,Z)
            grid off
            axis off
            view(l,k)
            m=m+1;
            aviobj = addframe(aviobj,getframe);
            if(m==2)   
                l=l+10;
                k=k+10;
                m=0;
            end
        end 
        m=0;
        for(j=0:5)
            m=m+1;
            t = 0:pi/10:((6-j)*pi);
            [Z,Y,X] = cylinder(4*cos(t));
            surf(X,Y,Z)
            grid off
            axis off
            view(l,k)
            aviobj = addframe(aviobj,getframe);
            if(m==2)   
                l=l+10;
                k=k+10;
                m=0;
            end
        end
        if strcmp(action,'spin')
            set([playHndl backHndl closeHndl],'Enable','on');
            aviobj = close(aviobj);
        end
    end
    
    
    
    % PLAY OR FULL
    l=-30;
    k=10;    
    if (strcmp(action,'play')|strcmp(action,'full'))
        startHndl=hndlList(1);
        spinHndl=hndlList(2);
        playHndl=hndlList(3);
        backHndl=hndlList(4);
        fullHndl=hndlList(5);
        closeHndl=hndlList(6);
        set([startHndl spinHndl playHndl backHndl fullHndl closeHndl],'Enable','off');
        
        for(i=1:6)
            t = 0:pi/10:i*pi;
            [Z,Y,X] = cylinder(4*cos(t));
            surf(X,Y,Z)
            grid off
            axis off
            view(l-10,k-10)
            aviobj = addframe(aviobj,getframe);
        end
        
        for(j=0:5)
            t = 0:pi/10:((6-j)*pi);
            [Z,Y,X] = cylinder(4*cos(t));
            surf(X,Y,Z)
            grid off
            axis off
            view(l-10,k-10)
            aviobj = addframe(aviobj,getframe);
        end
        if strcmp(action,'play')
            set([playHndl backHndl closeHndl],'Enable','on');
            aviobj = close(aviobj);
        end
    end
    
    
    
    
    % BACK OR FULL
    if (strcmp(action,'back')|strcmp(action,'full'))  
        startHndl=hndlList(1);
        spinHndl=hndlList(2);
        playHndl=hndlList(3);
        backHndl=hndlList(4);
        fullHndl=hndlList(5);
        closeHndl=hndlList(6);
        set([startHndl spinHndl playHndl backHndl fullHndl closeHndl],'Enable','off');
        m=1;
        for(i=1:6)
            t = 0:pi/10:i*pi;
            [Z,Y,X] = cylinder(4*cos(t));
            surf(X,Y,Z)
            grid off
            axis off
            m=m+1;
            if(m==2)   
                l=l-10;
                k=k-10;
                m=0;
            end
            view(l,k)
            aviobj = addframe(aviobj,getframe);
        end
        
        for(j=0:5)
            m=m+1;
            t = 0:pi/10:((6-j)*pi);
            [Z,Y,X] = cylinder(4*cos(t));
            surf(X,Y,Z)
            grid off
            axis off
            if(m==2)   
                l=l-10;
                k=k-10;
                m=0;
            end
            view(l,k)
            aviobj = addframe(aviobj,getframe);
        end
        aviobj = close(aviobj);
        if strcmp(action,'back')
            set([startHndl fullHndl closeHndl],'Enable','on');
        end
        if strcmp(action,'full')
            set([closeHndl],'Enable','on');
        end
        
    end
end


%CLOSE

if strcmp(action,'close') 
    close(gcf)
end
end;
